package com.mosty.base.manager.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mosty.base.manager.mapper.TbJcglXfNrmbMapper;
import com.mosty.base.manager.remote.TbBaseAdaptRemoteService;
import com.mosty.base.manager.service.TbJcglXfNrmbService;
import com.mosty.base.model.entity.jcgl.TbJcglXfNrmb;
import com.mosty.base.model.query.jcgl.TbJcglXfNrmbQuery;
import com.mosty.base.model.vo.base.DeptInfoVo;
import com.mosty.base.utils.UUIDGenerator;
import com.mosty.common.token.UserInfo;
import com.mosty.common.token.UserInfoManager;
import lombok.AllArgsConstructor;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@AllArgsConstructor
@Service
public class TbJcglXfNrmbServiceImpl extends ServiceImpl<TbJcglXfNrmbMapper, TbJcglXfNrmb>
        implements TbJcglXfNrmbService {

    private final TbBaseAdaptRemoteService tbBaseAdaptRemoteService;

    @Override
    public TbJcglXfNrmb queryById(String id) {
        return this.baseMapper.selectById(id);
    }

    @Override
    public IPage<TbJcglXfNrmb> paginQuery(TbJcglXfNrmbQuery query) {
        query.setSsbmdm(this.tbBaseAdaptRemoteService.getSsbm(query.getSsbmdm(), null));
        Page<TbJcglXfNrmb> tbJcglXfPage = this.baseMapper.selectPage(new Page<>(query.getPageCurrent(), query.getPageSize()), new LambdaQueryWrapper<TbJcglXfNrmb>()
                .likeRight(StringUtils.isNotBlank(query.getSsbmdm()), TbJcglXfNrmb::getSsbmdm, query.getSsbmdm())
                .like(StringUtils.isNotBlank(query.getNr()), TbJcglXfNrmb::getNr, query.getNr())
        );
        return tbJcglXfPage;
    }

    @Override
    public Integer insert(TbJcglXfNrmb xf) {
        if (StringUtils.isEmpty(xf.getSsbmdm())) {
            UserInfo userInfo = UserInfoManager.get();
            xf.setSsbmdm(userInfo.getDeptCode());
        }
        DeptInfoVo dept = this.tbBaseAdaptRemoteService.getOrgByOrgcode(xf.getSsbmdm());
        if (ObjectUtils.isNotEmpty(dept)) {
            xf.setSsbm(dept.getDeptname());
            xf.setSsbmid(dept.getDeptid());
            xf.setSsbmdm(dept.getDeptcode());
            xf.setSsxgajdm(dept.getFxjcode());
            xf.setSsxgajid(dept.getFxjid());
            xf.setSsxgaj(dept.getFxjname());
            xf.setSssgaj(dept.getDszname());
            xf.setSssgajdm(dept.getDszcode());
            xf.setSssgajid(dept.getDszid());
        }
        xf.setId(UUIDGenerator.getUUID());
        return this.baseMapper.insert(xf);
    }

    @Override
    public Integer update(TbJcglXfNrmb xf) {
        TbJcglXfNrmb tbJcglXfNrmb = this.baseMapper.selectById(xf.getId());
        if (ObjectUtils.isNotEmpty(tbJcglXfNrmb)) {
            tbJcglXfNrmb.setNr(xf.getNr());
            return this.baseMapper.updateById(xf);
        }
        return 0;

    }

    @Override
    public Boolean deleteById(String id) {
        int total = this.baseMapper.deleteById(id);
        return total > 0;
    }

    @Override
    public Boolean deleteByIds(List<String> id) {
        if (!CollectionUtils.isEmpty(id)) {
            int total = this.baseMapper.deleteBatchIds(id);
            return total > 0;
        }
        return false;
    }
}
